/* $Header:
 *
 *    Copyright (c) 1989, Larry Wall
 *
 *    You may distribute under the terms of the GNU General Public License
 *    as specified in the README file that comes with the perl 3.0 kit.
 *
 */

#include "EXTERN.h"
#include "perl.h"

exec sql include sqlca;
exec sql include sqlda;
int SqlDataLen;
char *SqlData;

exec sql begin declare section;
char *SqlBuf;
char errbuf[150];
exec sql end declare section;

IISQLDA *sqlda = (IISQLDA *)0;

init_sql ()
{
  int do_sql ();

  make_usub ("sql", 0, do_sql, "sql.sc");
}

int
do_sql(ix, sp, items)
     int ix;
     register int sp;
     register int items;
{
  static int inited = 0;
  STR **st = stack->ary_array + sp;
  register int i;
  register char *tmps;
  register STR *Str;		/* used in str_get and str_gnum macros */
  char *argstr = (char *)str_get (st [1]);

  if (!inited)
    {
      if (!getenv ("II_SYSTEM"))
	fatal ("II_SYSTEM is not set!\n");
    }

  if (!strncmp (argstr, "connect ", 8))
    {
      SqlBuf = &argstr [8];
      exec sql connect :SqlBuf;
      if (sqlca.sqlcode != 0)
	st [0] = &str_undef;
      else
	{
	  inited = 1;
	  st [0] = &str_yes;
	}
      return sp;
    }
  else if (!strcmp (argstr, "geterror"))
    {
      exec sql inquire_ingres (:errbuf = errortext);
      str_set(st [0], errbuf);
      return sp;
    }
  else if (!strcmp (argstr, "fetch"))
    return do_sql_fetch(sp, items);
  else
    {
      SqlBuf = argstr;
      if (do_sql_prepare ())
	st [0] = &str_undef;
      else
	st [0] = &str_yes;
      return sp;
    }
}

int
do_sql_prepare()
{
  int len;
  int save = SqlDataLen;
  int templen = 0;
  int done;
  int i;

	/* If there isn't one around, allocate the initial sqlda: */
  if (sqlda == (IISQLDA *)0)
    {
      sqlda = (IISQLDA *)malloc (sizeof (IISQLDA));
      if (sqlda == (IISQLDA *)0)
	{
	  return 1;
	}
      sqlda -> sqln = IISQ_MAX_COLS;
    }

	/* Prepare and describe the statement.   If there isn't space,
	   make more space. */
  for (done = 0; !done; )
    {
      exec sql prepare stmt from :SqlBuf;
      if (sqlca.sqlcode < 0)
	{
	  return 1;
	}
      exec sql describe stmt into :sqlda;
      if (sqlca.sqlcode < 0)
	{
	  return 1;
	}

      if (sqlda -> sqld < sqlda -> sqln)
	done = 1;
      else {
	i = sqlda -> sqld;
	free (sqlda);
	sqlda = (IISQLDA *)malloc (sizeof (IISQLDA)
			+ (i - IISQ_MAX_COLS) * sizeof (IISQLVAR));
	if (sqlda == (IISQLDA *)0)
	  {
	    return 1;
	  }
	sqlda -> sqln = i;
      } /* End if */
    } /* End for */

	/* sqlda -> sqld will be zero if it wasn't a select statement.
	   If that happens to be the case, just execute the statement
	   and return an error code. */
  if (sqlda -> sqld == 0)
    {
      exec sql execute stmt;
      if (sqlca.sqlcode < 0)
	{
	  return 1;
	}
      else
	return 0;
    }
	/* Otherwise, go down the sqlda allocating storage for things: */
  else
    {
      char *typename = "heck";

      for (i = 0; i < sqlda -> sqld; i++)
	{
	  int len;
	  int ind;
	  int type;
	  int baggage;

	  if (sqlda -> sqlvar [i].sqltype < 0)
	    {
	      ind = 1;
	      type = -sqlda -> sqlvar [i].sqltype;
	    }
	  else
	    {
	      ind = 0;
	      type = sqlda -> sqlvar [i].sqltype;
	    }

	  switch (type)
	    {
	    case 30:	/* integer */
	      typename = "INT";
	      len = sizeof (int);
	      sqlda -> sqlvar [i].sqltype = ind ? -30 : 30;
	      break;

	    case 31:	/* float */
	    case 5:		/* money */
	      typename = "FLOAT";
	      len = sizeof (double);
	      sqlda -> sqlvar [i].sqltype = ind ? -31 : 31;
	      break;

	    case 3:		/* date */
	      typename = "DATE";
	      len = 30;
	      sqlda -> sqlvar [i].sqltype = ind ? -21 : 21;
	      break;

	    case 20:	/* char */
	      typename = "CHAR";
	      len = sqlda -> sqlvar [i].sqllen;
	      baggage = 1;
	      break;

	    case 21:	/* varchar */
	      typename = "VARCHAR(%d)";
	      baggage = 1;
	      len = sqlda -> sqlvar [i].sqllen + 2;
	      break;
	    }

		/* For sqlind, make sure we're on a 16-bit boundary: */
	  if (templen & 1)
	    templen = (templen + 1) & ~1;

	  if (ind)
	    {
	      sqlda -> sqlvar [i].sqlind = (short *)templen;
	      templen += 2;
	    }
	  else
	    {
	      sqlda -> sqlvar [i].sqlind = (short *)0;
	    }

		/* For sqldata, make sure we're on a 32-bit boundary: */
	  if (templen & 3)
	    templen = (templen + 3) & ~3;

	  sqlda -> sqlvar [i].sqldata = (char *)templen;
	  templen += len + baggage;
	}

	/* Now that we've figured out how big everything is, let's make
	   sure there's space for it: */
      if (save < templen)
	{
	  	/* Free the old hunk if there is one, and then
		   allocate a new one of the appropriate size: */
	  if (SqlData != (char *)0)
	    free (SqlData);
	  SqlData = (char *)malloc (templen);
	  SqlDataLen = templen;
	  if (SqlData == (char *)0)
	    {
	      return 1;
	    }
	}
      else
	{
		/* There's more than enough space, so remember the old
		   size... */
	  SqlDataLen = save;
	} /* End if */

      for (i = 0; i < sqlda -> sqld; i++)
	{
	  if (sqlda -> sqlvar [i].sqltype < 0)
	    {
	      sqlda -> sqlvar [i].sqlind =
		(short *)(SqlData + (int)(sqlda -> sqlvar [i].sqlind));
	    } /* End if */

	  sqlda -> sqlvar [i].sqldata =
	    SqlData + (int)(sqlda -> sqlvar [i].sqldata);
	} /* End for */
    }
  exec sql declare curs cursor for stmt;
  if (sqlca.sqlcode < 0)
    {
      return 1;
    }
  exec sql open curs;
  if (sqlca.sqlcode < 0)
    {
      return 1;
    }
  return 0;
} /* End do_sql_prepare() */

int
do_sql_fetch(sp, items)
     register int sp;
     register int items;
{
  register STR *str;
  register ARRAY *ary = stack;
  register int i;
  register char *tmps;
  register STR *Str;		/* used in str_get and str_gnum macros */
  unsigned long len;

#ifdef DEBUG_SQL
printf ("Fetch:\n");
#endif
  exec sql fetch curs using descriptor :sqlda;

  if (sqlca.sqlcode != 0)
    {
      exec sql close curs;
#ifdef DEBUG_SQL
printf ("Done fetching\n");
#endif
      return 0;
    }
  
#ifdef DEBUG_SQL
  printf ("(");
#endif
  for (i = 0; i < sqlda -> sqld; i++)
    {
      int type;
      IISQLVAR *var = &sqlda -> sqlvar [i];
      union _data {
	char *c;
	double *f;
	float *sf;
	struct {
	  short l;
	  char c;
	} *v;
	int *i;
      } data;
      
#ifdef DEBUG_SQL
      if (i)
	printf (" ");
#endif

      data.c = var -> sqldata;
	      
      if (var -> sqltype < 0 && *(var -> sqlind) < 0)
	{
	  (void)astore(ary, sp++, str = str_mortal(&str_no));
	  str_set(str, "");
#ifdef DEBUG_SQL
	  printf ("<null value>");
#endif
	}
      else
	{
	  if (var -> sqltype < 0)
	    type = -var -> sqltype;
	  else
	    type = var -> sqltype;
	  
	  switch (type)
	    {
	    case 30:	/* int */
	      (void)astore(ary, sp++, str = str_mortal(&str_no));
	      str_numset(str, (double)(*data.i));
#ifdef DEBUG_SQL
	      printf ("%d", *data.i);
#endif
	      break;
		      
	    case 31:	/* float */
	      (void)astore(ary, sp++, str = str_mortal(&str_no));
	      if (var -> sqllen == sizeof (float))
		{
		  str_numset (str, (double)(*data.sf));
#ifdef DEBUG_SQL
	          printf ("%f", (double)(*data.sf));
#endif
		}
	      else
		{
	          str_numset(str, *data.f);
#ifdef DEBUG_SQL
	          printf ("%f", *data.f);
#endif
		}
	      break;
		      
	    case 20:	/* char */
	      data.c [var -> sqllen] = 0;
	      (void)astore(ary, sp++, str = str_mortal(&str_no));
	      str_set(str, data.c);
#ifdef DEBUG_SQL
	      printf ("'%s'", data.c);
#endif
	      break;

	    case 21:	/* varchar */
	      (&(data.v -> c)) [data.v -> l] = 0;
	      (void)astore(ary, sp++, str = str_mortal(&str_no));
	      str_set(str, &(data.v -> c));
#ifdef DEBUG_SQL
	      printf ("'%s'", data.v -> c);
#endif
	      break;
	    }
	}
    }
#ifdef DEBUG_SQL
  printf (")\n");
#endif
  return --sp;
}
